VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ConfigClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Function Save()

    Open App.Path & "\GamerBot.ini" For Output As #1
    
        Print #1, "[Connection]"
        Print #1, "Server=" & Server
        Print #1, "Channel=" & Channel
        Print #1, "Product=" & Product
        Print #1, "PreDelay=" & PreDelay
        Print #1, "Delay=" & Delay
        Print #1, "PostDelay=" & PostDelay
        Print #1, "GameName=" & GameName
        Print #1, ""
        Print #1, "[Profile0]"
        Print #1, "Username=" & Username(0)
        Print #1, "Password=" & Password(0)
        Print #1, "CDKey=" & CDKey(0)
        Print #1, ""
        Print #1, "[Profile1]"
        Print #1, "Username=" & Username(1)
        Print #1, "Password=" & Password(1)
        Print #1, "CDKey=" & CDKey(1)
        
    Close #1
    
End Function

Public Function Load()

    Server = mfncGetFromIni("Connection", "Server", App.Path & "\GamerBot.ini")
    Channel = mfncGetFromIni("Connection", "Channel", App.Path & "\GamerBot.ini")
    Product = UCase(mfncGetFromIni("Connection", "Product", App.Path & "\GamerBot.ini"))
    PreDelay = mfncGetFromIni("Connection", "PreDelay", App.Path & "\GamerBot.ini")
    Delay = mfncGetFromIni("Connection", "Delay", App.Path & "\GamerBot.ini")
    PostDelay = mfncGetFromIni("Connection", "PostDelay", App.Path & "\GamerBot.ini")
    GameName = mfncGetFromIni("Connection", "GameName", App.Path & "\GamerBot.ini")
    Username(0) = mfncGetFromIni("Profile0", "Username", App.Path & "\GamerBot.ini")
    Password(0) = mfncGetFromIni("Profile0", "Password", App.Path & "\GamerBot.ini")
    CDKey(0) = mfncGetFromIni("Profile0", "CDKey", App.Path & "\GamerBot.ini")
    Username(1) = mfncGetFromIni("Profile1", "Username", App.Path & "\GamerBot.ini")
    Password(1) = mfncGetFromIni("Profile1", "Password", App.Path & "\GamerBot.ini")
    CDKey(1) = mfncGetFromIni("Profile1", "CDKey", App.Path & "\GamerBot.ini")
    
    Select Case Product
        
        Case "RATS", "PXES"
        
            VersionBYTE = &HC7
            
        Case "RTSJ"
        
            VersionBYTE = &HA9
            
        Case "NB2W"
        
            VersionBYTE = &H4F
            
    End Select

End Function

Private Function mfncGetFromIni(strSectionHeader As String, strVariableName As String, strFileName As String) As String

    Dim strReturn As String
    
    strReturn = String(255, Chr(0))
    
    mfncGetFromIni = Left$(strReturn, GetPrivateProfileString(strSectionHeader, ByVal strVariableName, "", strReturn, Len(strReturn), strFileName))
    
End Function

Private Function mfncParseString(strIn As String, intOffset As Integer, strDelimiter As String) As String

    If Len(strIn) = 0 Or intOffset = 0 Then
    
        mfncParseString = ""
        Exit Function
        
    End If

    Dim intStartPos As Integer
    ReDim intDelimPos(10) As Integer
    Dim intStrLen As Integer
    Dim intNoOfDelims As Integer
    Dim intCount As Integer
    Dim strQuotationMarks As String
    Dim intInsideQuotationMarks As Integer
    
    strQuotationMarks = Chr(34) & Chr(147) & Chr(148)
    intInsideQuotationMarks = False
    
    For intCount = 1 To Len(strIn)

        If InStr(strQuotationMarks, Mid$(strIn, intCount, 1)) <> 0 Then
        
            intInsideQuotationMarks = (Not intInsideQuotationMarks)
            
        End If

        If (Not intInsideQuotationMarks) And (Mid$(strIn, intCount, 1) = strDelimiter) Then
        
            intNoOfDelims = intNoOfDelims + 1
            
            If (intNoOfDelims Mod 10) = 0 Then
            
                ReDim Preserve intDelimPos(intNoOfDelims + 10)
                
            End If
    
            intDelimPos(intNoOfDelims) = intCount
        
        End If

    Next intCount
    
    If intOffset > (intNoOfDelims + 1) Then
    
        mfncParseString = ""
        Exit Function
        
    End If
    
    If intOffset = 1 Then
    
        intStartPos = 1
        
    End If
    
    If intOffset = (intNoOfDelims + 1) Then
    
        If Right$(strIn, 1) = strDelimiter Then
        
            intStartPos = -1
            intStrLen = -1
            mfncParseString = ""
            Exit Function
            
        Else
        
            intStrLen = Len(strIn) - intDelimPos(intOffset - 1)
            
        End If
    
    End If
    
    If intStartPos = 0 Then
    
        intStartPos = intDelimPos(intOffset - 1) + 1
        
    End If
    
    If intStrLen = 0 Then
    
        intStrLen = intDelimPos(intOffset) - intStartPos
        
    End If
    
    mfncParseString = Mid$(strIn, intStartPos, intStrLen)

End Function
