VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LoginClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Function GetTickCount Lib "kernel32.dll" () As Long
Private Declare Function CheckRevision Lib "CheckRevision.dll" Alias "_CheckRevision@32" (ByVal FileExe As String, ByVal FileStormDll As String, ByVal FileBnetDll As String, ByVal HashText As String, ByRef version As Long, ByRef Checksum As Long, ByVal ExeInfo As String, ByVal MPQName As String) As Long
Private Declare Sub HashCDKey Lib "Hash.dll" Alias "?HashCDKey@@YGXPAK0000@Z" (ByRef lngKey As Long, ByRef lngSeed As Long, ByRef lngProdID As Long, ByRef lngValue1 As Long, ByRef lngValue2 As Long)
Private Declare Sub HashPass Lib "Hash.dll" Alias "?HashPassword@@YGXPBDHPAK1111@Z" (ByVal Password As String, ByVal nLength As Integer, ByRef lngSeed As Long, ByRef lngKey As Long, ByRef Value1 As Long, ByRef lngValue2 As Long, ByRef lngValue3 As Long)

Private ServerHash(0 To 1) As String
Private MPQName(0 To 1) As String
Private Hash(0 To 1) As String

Public Sub ParseP(Index As Integer, ByVal Data As String)

    On Error Resume Next
    
    Dim D As String
    Dim tmp As String
    Dim mpqend As Long
    
    PacketID = Asc(Mid(Data, 2, 1))
    
    Select Case PacketID
   
        Case &H1C
       
            If PreBoolean = False Then
            
                If Asc(Mid(Data, 5, 1)) = &H0 Then
                
                    Display MainForm.OutputText(0), True, True, vbWhite, "Authorizing Map..."
                    Display MainForm.OutputText(1), True, True, vbWhite, "Authorizing Map..."
                    
                    Game.Authorize
                    
                Else
                
                    Display MainForm.OutputText(0), True, True, vbRed, "Game Start Failed"
                    
                End If
                
            End If
       
        Case &H3C
        
            If PreBoolean = False Then
            
                If Asc(Mid(Data, 5, 1)) = &H2 Then
                
                    Display MainForm.OutputText(Index), True, True, vbGreen, "Game Started"
                    
                    Packet.SendPacket Index, &H0
                    
                    Display MainForm.OutputText(Index), True, True, vbWhite, "Game Playing"
                    
                Else
                
                    Display MainForm.OutputText(Index), True, True, vbRed, "Game Start Failed"
                    
                End If
            
            End If
       
        Case &H25
       
            MainForm.Socket(Index).SendData Data
       
        Case &H6
        
            D = Data
            MPQName(Index) = Mid(D, InStr(D, "I"), Len(D) - InStr(InStr(D, "I"), D, Chr(0)))
            mpqend = InStr(InStr(D, "I"), D, Chr(0))
            MPQName(Index) = Left(MPQName(Index), InStr(MPQName(Index), Chr(0)) - 1)
            Hash(Index) = Mid(D, mpqend + 1, InStr(mpqend + 1, D, Chr(0)) - 1)
            Hash(Index) = Left(Hash(Index), InStr(Hash(Index), Chr(0)) - 1)
            
            Dim version As Long
            Dim Checksum As Long
            Dim ExeInfo As String
            Dim Result As Long
            
            Packet.InsertNonNTString "68XI" & Product
            Packet.InsertDWORD VersionBYTE
            
            ExeInfo = Space(256)
            If Product = "NB2W" Then
                Result = CheckRevision(App.Path & "\" & Product & "\WarCraft II BNE.exe", App.Path & "\" & Product & "\storm.dll", App.Path & "\" & Product & "\battle.snp", Hash(Index), version, Checksum, ExeInfo, MPQName(Index))
            Else
                Result = CheckRevision(App.Path & "\" & Product & "\StarCraft.exe", App.Path & "\" & Product & "\storm.dll", App.Path & "\" & Product & "\battle.snp", Hash(Index), version, Checksum, ExeInfo, MPQName(Index))
            End If
            
            Packet.InsertDWORD version
            Packet.InsertDWORD Checksum
            
            NullTruncString ExeInfo
            
            Packet.InsertNTString ExeInfo
            
            If ExeInfo = Space(256) Then
            
                Display MainForm.OutputText(Index), True, True, vbRed, "Hashes Could Not Be Located"
                Exit Sub
                
            End If
            
            Packet.SendPacket Index, 7
            
            Display MainForm.OutputText(Index), True, True, &HFF8080, "Verifying Product Revision"
    
        Case &H7
            strData = Mid(Data, 5, 1)
            Select Case strData
        
                Case Chr(2)
                
                    Display MainForm.OutputText(Index), True, True, vbGreen, "Verified Product Revision"
                    
                    Packet.SendPacket Index, &H2D
                    
                    Packet.InsertNonNTString "tenb"
                    Packet.SendPacket Index, &H14
    
                Case Else
                
                    Display MainForm.OutputText(Index), True, True, vbRed, "Unable To Verify Product Revision"
    
            End Select
          
        Case &H1D
        
            ServerHash(Index) = Right(Data, 4)
    
        Case &H2D
        
            Display MainForm.OutputText(Index), True, True, &HFF8080, "Verifying CD Key"
            
            SendCDKey Index
        
        Case &H30, &H36
    
            Select Case Mid(Data, 5, 1)
            
                Case Chr(1)
                
                    Display MainForm.OutputText(Index), True, True, vbGreen, "Verified CD Key"
                    Display MainForm.OutputText(Index), True, True, &HFF8080, "Verifying Logon Information"
                   
                    SendUsernamePassword Index
                    
                Case Else
                    Display MainForm.OutputText(Index), True, True, vbRed, "Unable To Verify CD Key"
                
            End Select
            
        Case &H29
        
            If Mid(Data, 5, 1) = Chr(1) Then
            
                Display MainForm.OutputText(Index), True, True, vbGreen, "Verified Logon Information"
                Display MainForm.OutputText(Index), True, True, &HFF8080, "Entering Chat..."
                    
                Packet.InsertNTString Username(Index)
                Packet.InsertBYTE 0
                Packet.SendPacket Index, &HA
                
                Packet.InsertNonNTString Product
                Packet.SendPacket Index, &HB
                
                Packet.InsertDWORD 2
                Packet.InsertNTString Channel
                Packet.SendPacket Index, &HC
            
            Else
            
                Display MainForm.OutputText(Index), True, True, vbRed, "Unable To Verify Logon Information"
    
            End If
            
        Case &HA
        
            If MainForm.Socket(1).State <> 7 Then MainForm.Socket(1).Connect Server, 6112
            Display MainForm.OutputText(Index), True, True, vbGreen, "Entered Chat"
            If Index = 0 Then MainForm.PostGame.Enabled = True
            Packet.InsertNTString "/dnd You Can Hide in My Shower - Gamer Bot 1.10"
            Packet.SendPacket Index, &HE
            
    End Select

End Sub

Public Function SEND_CLIENTID(Index As Integer)

    MainForm.Socket(Index).SendData Chr(1)

    With Packet
    
        .InsertDWORD 1
        .InsertDWORD 0
        .InsertDWORD 0
        .InsertDWORD 0
        .InsertDWORD 1
        .InsertNTString "0x25"
        .InsertNTString "0x25"
        .SendPacket Index, &H1E
        
        .InsertNonNTString "68XI" & Product
        .InsertDWORD VersionBYTE
        .InsertDWORD 0
        .SendPacket Index, &H6

    End With
    
End Function

Public Sub SendCDKey(Index As Integer)

    If Product = "RTSJ" Then
    
        Packet.InsertDWORD &H0
        Packet.InsertNTString CDKey(Index)
        Packet.InsertNTString Username(Index)
        Packet.SendPacket Index, &H30
        
        Exit Sub
        
    End If

    Dim lngSeed As Long, lngKey As Long, lngProdID As Long, lngValue1 As Long, lngValue2 As Long, lngValue3 As Long
    Dim dblProdID As Double, dblValue1 As Double, dblValue2 As Double, dblSeed As Double, dblkey As Double

    dblSeed = Val("&h" & StrToHex(StrReverse(ServerHash(Index))))
    dblkey = GetTickCount()
    lngSeed = CLng(dblSeed)
    lngKey = CLng(dblkey)
    Call DecodeCDKey(CDKey(Index), dblProdID, dblValue1, dblValue2)
    lngProdID = CLng(dblProdID)
    lngValue1 = CLng(dblValue1)
    lngValue2 = CLng(dblValue2)
    Call HashCDKey(lngKey, lngSeed, lngProdID, lngValue1, lngValue2)
    
    With Packet
    
        .InsertDWORD &H0
        .InsertDWORD Len(CDKey(Index))
        .InsertDWORD CLng(dblProdID)
        .InsertDWORD CLng(dblValue1)
        .InsertDWORD CLng(dblSeed)
        .InsertDWORD CLng(dblkey)
        .InsertDWORD lngKey
        .InsertDWORD lngSeed
        .InsertDWORD lngProdID
        .InsertDWORD lngValue1
        .InsertDWORD lngValue2
        .InsertNTString Username(Index)
        .SendPacket Index, &H36
    
    End With

End Sub

Public Sub SendUsernamePassword(Index As Integer)

    Dim dbseed As Double
    Dim dblkey As Double
    Dim dblSeed As Double
    Dim lngSeed As Long
    Dim lngKey As Long
    Dim lngValue1 As Long
    Dim lngValue2 As Long
    Dim lngValue3 As Long
    
    dblSeed = Val("&h" & StrToHex(StrReverse(ServerHash(Index))))
    dblkey = GetTickCount
    lngSeed = CLng(dblSeed)
    lngKey = CLng(dblkey)
    HashPass Password(Index), Len(Password(Index)), lngKey, lngSeed, lngValue1, lngValue2, lngValue3
    
    With Packet
    
        .InsertDWORD CLng(dblkey)
        .InsertDWORD CLng(dblSeed)
        .InsertDWORD lngKey
        .InsertDWORD lngSeed
        .InsertDWORD lngValue1
        .InsertDWORD lngValue2
        .InsertDWORD lngValue3
        .InsertNTString Username(Index)
        .SendPacket Index, &H29
    
    End With
    
End Sub

Public Function StrToHex(ByVal String1 As String) As String
On Error Resume Next
    Dim strTemp As String, strReturn As String, i As Long
    
    For i = 1 To Len(String1)
        strTemp = Hex(Asc(Mid(String1, i, 1)))
    If Len(strTemp) = 1 Then strTemp = "0" & strTemp
    
    strReturn = strReturn & " " & strTemp
    
    Next i
        StrToHex = strReturn
    
End Function

Public Sub DecodeCDKey(ByVal sCDKey As String, ByRef dProductId As Double, ByRef dValue1 As Double, ByRef dValue2 As Double)
On Error Resume Next
    sCDKey = Replace(sCDKey, "-", "")
    sCDKey = Replace(sCDKey, " ", "")
    sCDKey = KillNull(sCDKey)
    
    If Len(sCDKey) = 13 Then
        sCDKey = DecodeStarcraftKey(sCDKey)
    ElseIf Len(sCDKey) = 16 Then
        sCDKey = DecodeD2Key(sCDKey)
    Else
        Exit Sub
    End If
    
    dProductId = Val("&H" & Left$(sCDKey, 2))
    
    If Len(sCDKey) = 13 Then
        dValue1 = Val(Mid$(sCDKey, 3, 7))
        dValue2 = Val(Mid$(sCDKey, 10, 3))

    ElseIf Len(sCDKey) = 16 Then
        dValue1 = Val("&H" & Mid$(sCDKey, 3, 6))
        dValue2 = Val("&H" & Mid$(sCDKey, 9))
    End If
    
End Sub

Public Function DecodeD2Key(ByVal key As String) As String
    Dim R As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, _
    c As Byte, bValid As Boolean, i As Integer, aryKey(0 To 15) As String, _
    codevalues As String
    
    codevalues = "246789BCDEFGHJKMNPRTVWXZ"
    R = 1
    keyvalue = 0
    
    For i = 1 To 16
    
        aryKey(i - 1) = Mid$(key, i, 1)
        
    Next i
    
    For i = 0 To 15 Step 2
        c1 = InStr(1, codevalues, aryKey(i)) - 1
        If c1 = -1 Then c1 = &HFF
        n = c1 * 3
        c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
        If c2 = -1 Then c2 = &HFF
        n = c2 + n * 8
        
        If n >= &H100 Then
        
            n = n - &H100
            keyvalue = keyvalue Or R
            
        End If
        
        n2 = n
        n2 = RShift(n2, 4)
        aryKey(i) = GetHexValue(n2)
        aryKey(i + 1) = GetHexValue(n)
        R = LShift(R, 1)
        
Cont:

    Next i
    
    v = 3
    
    For i = 0 To 15
    
        c = GetNumValue(aryKey(i))
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v And &HFF
    
    For i = 15 To 0 Step -1
    
        c = Asc(aryKey(i))
        
        If i > 8 Then
        
            n = i - 9
            
        Else
        
            n = &HF - (8 - i)
            
        End If
        
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(c)
        
    Next i
    
    v2 = &H13AC9741
    
    For i = 15 To 0 Step -1
    
        c = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(c)
        
        If Val(c) <= Asc("7") Then
        
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
            
        ElseIf Val(c) < Asc("A") Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = Chr$(c2)
            
        End If
        
    Next i
    
    DecodeD2Key = Join(aryKey, "")
    
    Erase aryKey()
    
End Function

Public Function DecodeStarcraftKey(ByVal sKey As String) As String
On Error Resume Next
    Dim R As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, c As Byte, _
    bValid As Boolean, i As Integer, aryKey(0 To 12) As String
    
    For i = 1 To 13
    
        aryKey(i - 1) = Mid$(sKey, i, 1)
        
    Next i
    
    v = 3
    
    For i = 0 To 11
    
        c = aryKey(i)
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v Mod 10
    
    If Hex(v) = aryKey(12) Then
    
        bValid = True
        
    End If
    
    v = 194
    
    For i = 11 To 0 Step -1
    
        If v < 7 Then GoTo continue
        c = aryKey(i)
        n = CInt(v / 12)
        n2 = v Mod 12
        v = v - 17
        c2 = aryKey(n2)
        aryKey(i) = c2
        aryKey(n2) = c
        
    Next i
    
continue:

    v2 = &H13AC9741
    
    For i = 11 To 0 Step -1
    
        c = UCase$(aryKey(i))
        aryKey(i) = c
        
        If Asc(c) <= Asc("7") Then
        
            v = v2
            c2 = v And &HFF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(CLng(v), 3)
            aryKey(i) = c2
            v2 = v
            
        ElseIf Asc(c) < 65 Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = c2
            
        End If
        
    Next i
    
    DecodeStarcraftKey = Join(aryKey, "")
    
    Erase aryKey()
    
End Function





Public Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
LShift = CDbl(pnValue * (2 ^ pnShift))
End Function


Public Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
RShift = CDbl(pnValue \ (2 ^ pnShift))
End Function


Private Function Hex2Dec(ByVal sHex As String) As Long
On Error Resume Next
    Dim i As Integer
    Dim nDec As Long
    Const HexChar As String = "0123456789ABCDEF"
    


    For i = Len(sHex) To 1 Step -1
        nDec = nDec + (InStr(1, HexChar, Mid(sHex, i, 1)) - 1) * 16 ^ (Len(sHex) - i)
    Next i
    Hex2Dec = CStr(nDec)
End Function
Public Function KillNull(ByVal Text As String) As String
    Dim i As Integer
    i = InStr(1, Text, Chr(0))
    If i = 0 Then
        KillNull = Text
        Exit Function
    End If
    KillNull = Left(Text, i - 1)
End Function


Public Function CVL(x As String) As Long
On Error Resume Next
    If Len(x) < 4 Then
        MsgBox "CVL(): String too short"
        Stop
    End If
    'CopyMemory CVL, ByVal x, 4
End Function


' Converts a string to an Integer
Private Function CVI(x As String) As Integer
On Error Resume Next
    If Len(x) < 2 Then
        MsgBox "CVI(): String too short"
        Stop
    End If
    
    'CopyMemory CVI, ByVal x, 2
End Function
Public Function GetHexValue(ByVal v As Long) As String

    v = v And &HF
    
    If v < 10 Then
    
        GetHexValue = Chr$(v + &H30)
        
    Else
    
        GetHexValue = Chr$(v + &H37)
        
    End If
    
End Function

Public Function GetNumValue(ByVal c As String) As Long
On Error Resume Next
    c = UCase(c)
    
    If IsNumeric(c) Then
    
        GetNumValue = Asc(c) - &H30
        
    Else
    
        GetNumValue = Asc(c) - &H37
        
    End If
    
End Function
Public Sub NullTruncString(ByRef Text As String)
On Error Resume Next
    Dim i As Integer
    
    i = InStr(Text, Chr(0))
    If i = 0 Then Exit Sub
    
    Text = Left(Text, i - 1)
End Sub
Public Function HexToStr(ByVal Hex1 As String) As String
On Error Resume Next
    Dim strTemp As String, strReturn As String, i As Long
    If Len(Hex1) Mod 2 <> 0 Then Exit Function
    For i = 1 To Len(Hex1) Step 2
    strReturn = strReturn & Chr(Val("&H" & Mid(Hex1, i, 2)))
    Next i
    HexToStr = strReturn
End Function


