VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PacketClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numbytes As Long)

Private Buffer As String

Public Function InsertDWORD(Data As Long)

    Buffer = Buffer & MakeDWORD(Data)
    
End Function

Public Function InsertWORD(Data As Integer)

    Buffer = Buffer & MakeWORD(Data)
    
End Function

Public Function InsertBYTE(Data As Integer)

    Buffer = Buffer & Chr(Data)
    
End Function

Public Function InsertNTString(Data As String)

    Buffer = Buffer & Data & Chr(0)
    
End Function

Public Function InsertNonNTString(Data As String)

    Buffer = Buffer & Data
    
End Function

Function MakeDWORD(Value As Long) As String

    Dim Result As String * 4
    CopyMemory ByVal Result, Value, 4
    MakeDWORD = Result
    
End Function

Function MakeWORD(Value As Integer) As String

    Dim Result As String * 2
    CopyMemory ByVal Result, Value, 2
    MakeWORD = Result
    
End Function

Public Function Clear()

    Buffer = ""
    
End Function

Public Function SendPacket(Index As Integer, PacketID As Byte)

    If MainForm.Socket(Index).State <> sckConnected Then: Exit Function
    
    MainForm.Socket(Index).SendData Chr(&HFF) & Chr(PacketID) & MakeWORD(Len(Buffer) + 4) & Buffer
    Clear

End Function

Public Function SendAuthPacket(PacketID As Byte)

    If MainForm.AuthSocket.State <> sckConnected Then: Exit Function
    
    MainForm.AuthSocket.SendData Chr(PacketID) & Buffer
    Clear

End Function

